﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using Syncfusion.Mvc.DocIO.Web;
using System.Drawing;
using System.IO;
using Syncfusion.OfficeChart;

namespace GenerateWord.Controllers
{
    public class HomeController : Controller
    {
        string dataPath;
        #region Generate Word
        public ActionResult Index(string Group1)
        {
            if (Group1 == null)
                return View();

            dataPath = ResolveApplicationDataPath("\\", "Data");
            //Creates a new Word document
            WordDocument document = new WordDocument();

            //Adds section to the document
            IWSection sec = document.AddSection();

            //Adds paragraph to the section
            IWParagraph paragraph = sec.AddParagraph();

            //Inputs data for chart
            object[][] data = new object[4][];

            for (int i = 0; i < 4; i++)
                data[i] = new object[3];

            data[1][0] = "5/22/2017";
            data[2][0] = "2/6/2017";
            data[3][0] = "6/30/2017";

            data[0][1] = "Score";
            data[1][1] = 6;
            data[2][1] = 6;
            data[3][1] = 12;

            data[0][2] = "Norm";
            data[1][2] = 4;
            data[2][2] = 4;
            data[3][2] = 7;

            //Creates and Appends chart to the paragraph with excel stream as parameter
            WChart chart = paragraph.AppendChart(data, 470, 300);

            //Set the title for Chart.
            chart.ChartTitle = "Chart Sample";

            chart.ChartTitleArea.FontName = "Calibri";
            chart.IsSeriesInRows = false;
            chart.ChartTitleArea.Size = 14;
            chart.ChartArea.Border.LinePattern = OfficeChartLinePattern.None;

            //Sets name to chart series            
            chart.Series[0].SerieType = OfficeChartType.Column_Clustered;
            chart.Series[0].Name = "Score";
            chart.PrimaryValueAxis.Title = "Score";
            chart.PrimaryValueAxis.MaximumValue = 14;
            chart.PrimaryValueAxis.MinimumValue = 0;

            //Sets name to chart series            
            chart.Series[1].SerieType = OfficeChartType.Line;
            chart.Series[1].Name = "Norm";
            chart.Series[1].UsePrimaryAxis = false;
            chart.SecondaryValueAxis.Title = "Norm";
            chart.Series[1].SerieFormat.LineProperties.LineWeight = OfficeChartLineWeight.Medium;


            chart.SecondaryValueAxis.TickLabelPosition = OfficeTickLabelPosition.TickLabelPosition_High;
            chart.SecondaryValueAxis.MajorTickMark = OfficeTickMark.TickMark_Outside;
            // Sets MaximumValue of SecondaryValueAxis.
            chart.SecondaryValueAxis.MaximumValue = 9;
            // Sets MinimumValue of SecondaryValueAxis.
            chart.SecondaryValueAxis.MinimumValue = 1;
            // Sets MajorUnit of SecondaryValueAxis.
            chart.SecondaryValueAxis.MajorUnit = 2;

            chart.Series[0].UsePrimaryAxis = true;
            chart.PrimaryCategoryAxis.CategoryType = OfficeCategoryType.Category;
            //Set the date format of PrimaryCategoryAxis.
            chart.PrimaryCategoryAxis.NumberFormat = "dd-MM-yyyy";


            #region saveOption
            if (Group1 == "Word97To2003")
            {
                //Save as .doc Word 97-2003 format
                return document.ExportAsActionResult("Sample.doc", FormatType.Doc, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);
            }
            //Save as .docx Word 2007 format
            else if (Group1 == "Word2007")
            {
                return document.ExportAsActionResult("Sample.docx", FormatType.Word2007, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);

            }
            //Save as .docx Word 2010 format
            else if (Group1 == "Word2010")
            {
                return document.ExportAsActionResult("Sample.docx", FormatType.Word2010, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);

            }
            //Save as .docx Word 2013 format
            else if (Group1 == "Word2013")
            {
                return document.ExportAsActionResult("Sample.docx", FormatType.Word2013, HttpContext.ApplicationInstance.Response, HttpContentDisposition.Attachment);

            }
            #endregion saveOption

            return View();
        }
        #endregion Getting Started
        /// <summary>
        /// Data folder path is resolved from requested page physical path
        /// </summary>
        /// <param name="fileName"></param>
        /// <param name="folderName"></param>
        /// <returns></returns>
        protected string ResolveApplicationDataPath(string fileName, string folderName)
        {
            string dataPath = null;
            dataPath = Server.MapPath(@"App_Data//Images//").ToString();
            return string.Format("{0}\\{1}", dataPath, fileName);
        }
    }
}
